## marsyas-0.5.0-8.src.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.9)
# Note: Policies have to be repeated after every minimum cmake version declaration
if(POLICY CMP0020)
  # Accept new policy related to automatically linking Qt apps to qtmain.lib on Windows
  cmake_policy(SET CMP0020 NEW)
endif()

# Accept policy to ignore COMPILE_DEFINITIONS_<CONFIG> properties of targets and directories
# (Instead, use generator expressions for configuration-dependent compile definitions)
if(POLICY CMP0043)
  cmake_policy(SET CMP0043 NEW)
endif()

# Accept policy: use rpath on Mac OS X by default
if (POLICY CMP0042)
  cmake_policy(SET CMP0042 NEW)
endif()

# Mac OS X: rpath handling
set(CMAKE_MACOSX_RPATH TRUE)
set(CMAKE_INSTALL_RPATH "@loader_path/../lib")



option(MARSYAS_DOCUMENTATION_ONLY "Only build documentation, not program sources" OFF)

# If only building documentation, tell CMake
# not to check for any language compilers.
if(MARSYAS_DOCUMENTATION_ONLY)
  set(MARSYAS_LANGUAGES NONE)
endif()



project(marsyas ${MARSYAS_LANGUAGES})

set(MARSYAS_VERSION_MAJOR "0")
set(MARSYAS_VERSION_MINOR "5")
set(MARSYAS_VERSION_PATCH "0")
set(MARSYAS_VERSION
  ${MARSYAS_VERSION_MAJOR}.${MARSYAS_VERSION_MINOR}.${MARSYAS_VERSION_PATCH})

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake-modules")

include(${CMAKE_SOURCE_DIR}/cmake-modules/utilities.cmake)

if(NOT MARSYAS_DOCUMENTATION_ONLY)
  if (MARSYAS_TESTS)
    enable_testing()
    include(CTest)
  endif()

  add_subdirectory(src)
endif()

add_subdirectory(doc)

=== doc/CMakeLists.txt ===
## find required programs
find_program(TEXI2PDF NAMES texi2pdf PATHS $ENV{PATH})
if(TEXI2PDF)
  set(TEXI2PDF ${TEXI2PDF} -b)
endif()

find_program(MAKEINFO NAMES makeinfo PATHS $ENV{PATH})
if(MAKEINFO)
  set(TEXI2HTML ${MAKEINFO} --html
    --css-include=${CMAKE_CURRENT_SOURCE_DIR}/marsyas.css)
endif()

find_program(DOXYGEN NAMES doxygen PATHS $ENV{PATH})

if(NOT TEXI2PDF OR NOT TEXI2HTML OR NOT DOXYGEN)
  message(STATUS "Documentation can not be built, because either texi2pdf, texi2html, or Doxygen is not installed.")
  return()
endif()

## prep
set(OUT-WWW ${CMAKE_CURRENT_BINARY_DIR}/out-www/)
make_directory(${OUT-WWW})
configure_file(index.html.in ${OUT-WWW}/index.html)

make_directory(${OUT-WWW}/manual/)
set(MANUAL_DIR ${OUT-WWW}/manual/)
# ugly, but works
make_directory(${MANUAL_DIR}/marsyas-user/)
make_directory(${MANUAL_DIR}/marsyas-devel/)
make_directory(${MANUAL_DIR}/marsyas-cookbook/)
make_directory(${MANUAL_DIR}/marsyas-user/images/)
make_directory(${MANUAL_DIR}/marsyas-devel/images/)
make_directory(${MANUAL_DIR}/marsyas-cookbook/images/)

file(GLOB PNG_IMAGES images/*.png)
foreach(PNG_FILE ${PNG_IMAGES})
# ugly, but works
	configure_file(${PNG_FILE} ${MANUAL_DIR}/marsyas-user/images/ COPYONLY)
	configure_file(${PNG_FILE} ${MANUAL_DIR}/marsyas-devel/images/ COPYONLY)
	configure_file(${PNG_FILE} ${MANUAL_DIR}/marsyas-cookbook/images/ COPYONLY)
endforeach(PNG_FILE)


## build docs
add_custom_command(
	OUTPUT ${MANUAL_DIR}/marsyas-user.pdf
	COMMAND ${TEXI2PDF}
	ARGS ${CMAKE_CURRENT_SOURCE_DIR}/marsyas-user.texi
	WORKING_DIRECTORY ${MANUAL_DIR}
)

add_custom_command(
	OUTPUT ${MANUAL_DIR}/marsyas-user/index.html
	COMMAND ${TEXI2HTML}
	ARGS ${CMAKE_CURRENT_SOURCE_DIR}/marsyas-user.texi
	WORKING_DIRECTORY ${MANUAL_DIR}
)

add_custom_command(
	OUTPUT ${MANUAL_DIR}/marsyas-devel.pdf
	COMMAND ${TEXI2PDF}
	ARGS ${CMAKE_CURRENT_SOURCE_DIR}/marsyas-devel.texi
	WORKING_DIRECTORY ${MANUAL_DIR}
)

add_custom_command(
	OUTPUT ${MANUAL_DIR}/marsyas-devel/index.html
	COMMAND ${TEXI2HTML}
	ARGS ${CMAKE_CURRENT_SOURCE_DIR}/marsyas-devel.texi
	WORKING_DIRECTORY ${MANUAL_DIR}
)

add_custom_command(
	OUTPUT ${MANUAL_DIR}/marsyas-cookbook.pdf
	COMMAND ${TEXI2PDF}
	ARGS ${CMAKE_CURRENT_SOURCE_DIR}/marsyas-cookbook.texi
	WORKING_DIRECTORY ${MANUAL_DIR}
)

add_custom_command(
	OUTPUT ${MANUAL_DIR}/marsyas-cookbook/index.html
	COMMAND ${TEXI2HTML}
	ARGS ${CMAKE_CURRENT_SOURCE_DIR}/marsyas-cookbook.texi
	WORKING_DIRECTORY ${MANUAL_DIR}
)

configure_file( Doxyfile.in Doxyfile @ONLY )

make_directory(${OUT-WWW}/sourceDoc)

add_custom_command(
	OUTPUT ${OUT-WWW}/sourceDoc/index.html
	COMMAND ${DOXYGEN} ARGS Doxyfile
)

add_custom_target(doxy
	DEPENDS ${OUT-WWW}/sourceDoc/index.html
)

add_custom_target(docs
	DEPENDS ${MANUAL_DIR}/marsyas-user.pdf
	DEPENDS ${MANUAL_DIR}/marsyas-user/index.html
	DEPENDS ${MANUAL_DIR}/marsyas-devel.pdf
	DEPENDS ${MANUAL_DIR}/marsyas-devel/index.html
	DEPENDS ${MANUAL_DIR}/marsyas-cookbook.pdf
	DEPENDS ${MANUAL_DIR}/marsyas-cookbook/index.html
	DEPENDS ${OUT-WWW}/sourceDoc/index.html
)

file(COPY ${PNG_IMAGES} DESTINATION ${OUT-WWW}/marsyas-user/images/)
file(COPY examples DESTINATION ${OUT-WWW}/manual)

=== src/CMakeLists.txt ===

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  message(FATAL_ERROR "CMake initialized in the wrong directory. Please initialize CMake with the top-level Marsyas directory as source directory.")
endif()

## basic CMAKE vars
if (APPLE)
  mark_as_advanced (CMAKE_OSX_ARCHITECTURES)
  mark_as_advanced (CMAKE_OSX_SYSROOT)
endif (APPLE)

set (CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)
set (CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set (CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)

## find OS
if(UNIX)
  if(APPLE)
    set(MARSYAS_MACOSX 1)
  elseif(CYGWIN)
    set(MARSYAS_CYGWIN 1)
  else(APPLE)
    set(MARSYAS_LINUX 1)
  endif(APPLE)
elseif(MINGW)
  set(MARSYAS_MINGW 1)
elseif(MSVC)
  set(MARSYAS_WIN32 1)
endif(UNIX)

# for testing
#MESSAGE( STATUS "CMAKE_SYSTEM: " ${CMAKE_SYSTEM} )
#MESSAGE( STATUS "MARSYAS_OPERATION_SYSTEM: LINUX " ${MARSYAS_LINUX})
#MESSAGE( STATUS "MARSYAS_OPERATION_SYSTEM: OSX " ${MARSYAS_MACOSX})
#MESSAGE( STATUS "MARSYAS_OPERATION_SYSTEM: WIN32 " ${MARSYAS_WIN32})
#MESSAGE( STATUS "MARSYAS_OPERATION_SYSTEM: MINGW " ${MARSYAS_MINGW})
#MESSAGE( STATUS "MARSYAS_OPERATION_SYSTEM: CYGWIN " ${MARSYAS_CYGWIN})

include (TestBigEndian)
test_big_endian(MARSYAS_BIGENDIAN)

## user options
include (marsyas-options)

## detect packages
include (marsyas-detect)

## general setup

# Include current directory, so that include paths of form <marsyas/...>
# work just like when installed.
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

if(WITH_CPP11)
  if(CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "-std=c++11 ${CMAKE_CXX_FLAGS}")
  elseif(${CMAKE_CXX_COMPILER_ID} STREQUAL Clang)
    set(CMAKE_CXX_FLAGS "-std=c++11 -stdlib=libc++ ${CMAKE_CXX_FLAGS}")
  endif()
endif()

## CONFIG.H
configure_file(config.h.in ${CMAKE_BINARY_DIR}/config.h)
include_directories(${CMAKE_BINARY_DIR})
## oops, don't install this!  -gp
#install(FILES ${CMAKE_BINARY_DIR}/config.h DESTINATION include/marsyas)

add_subdirectory(otherlibs)

## setup includes
include (marsyas-includes)

## setup oslibs
include (marsyas-oslibs)

## next level

add_subdirectory(marsyas)

if (MARSYAS_BUILD_APPS)
  add_subdirectory(apps)
  if(WITH_QT)
    add_subdirectory(qt5apps)
  endif()
endif (MARSYAS_BUILD_APPS)

if (SWIG_FOUND)
  add_subdirectory(swig)
endif (SWIG_FOUND)

if(WITH_QT4)
  SET(QT_USE_QTNETWORK ON)
  SET(QT_USE_QTXML ON)
  if(WITH_OPENGL)
    SET(QT_USE_QTOPENGL TRUE)
  endif()
  include (${QT_USE_FILE})
  add_subdirectory(Qt4Apps)
endif()

if (VAMP_FOUND)
  add_subdirectory(mvamp)
endif (VAMP_FOUND)

if (MAXSDK_FOUND)
  add_subdirectory(marsyas_max-msp)
endif (MAXSDK_FOUND)

if (PD_FOUND)
  add_subdirectory(marsyas_pd)
endif (PD_FOUND)

## tests, for verification
if (MARSYAS_TESTS)
  add_subdirectory (tests)
endif (MARSYAS_TESTS)

## bundling
if(WIN32)
  include(InstallRequiredSystemLibraries)

  ## 'fixup_bundle' only needs one executable in a directory to fix up all the siblings.
  add_custom_target(bundle
    COMMAND ${CMAKE_COMMAND}
    -DMARSYAS_BUNDLE_EXECUTABLES=${CMAKE_INSTALL_PREFIX}/bin/bextract.exe
    -DMARSYAS_BUNDLE_DIRS=${CMAKE_LIBRARY_PATH}
    -P ${CMAKE_SOURCE_DIR}/cmake-modules/marsyas-bundle.cmake
  )
endif()

## packaging
include(marsyas-package)

=== src/Qt4Apps/CMakeLists.txt ===
## global includes
set(APP_LIBS marsyas ${OS_LIBS} ${QT_LIBRARIES})
if(MARSYAS_OPENGL)
  set(APP_LIBS ${APP_LIBS} ${OPENGL_LIBRARIES})
endif()

include_directories(common)

## define macro for Qt4 apps
macro (marsyas_qt4app APP_NAME APP_SOURCES APP_HEADERS APP_UI APP_RESOURCES)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

qt4_wrap_cpp(APP_MOC_SOURCES ${APP_HEADERS})
qt4_wrap_ui(APP_UIHEADERS ${APP_UI})
qt4_add_resources(APP_RESOURCE_FILES ${APP_RESOURCES})

add_executable(${APP_NAME} ${APP_SOURCES} ${APP_UIHEADERS}
  ${APP_MOC_SOURCES} ${APP_RESOURCE_FILES})

target_link_Libraries(${APP_NAME} ${APP_LIBS})

# Do not install on Mac OS because of absolute paths to Qt dependencies
if(NOT APPLE)
  install(TARGETS ${APP_NAME} DESTINATION bin)
endif()

endmacro (marsyas_qt4app)

## build static lib and apps
if(MARSYAS_REALTIME)
  add_subdirectory(MarGrid)
endif()

=== src/apps/CMakeLists.txt ===
## BUILD MACRO

macro(marsyas_app APP)
  add_executable(${APP} ${ARGN})
  include_directories(
    ${GSTREAMER_INCLUDE_DIRS}
    ${PNGWRITER_INCLUDE_DIR}
    ${OSC_INCLUDE_DIR}
    ${FREETYPE_INCLUDE_DIR_freetype2}
    ${FREETYPE_INCLUDE_DIR_ft2build}
  )
  target_link_libraries(${APP} marsyas)
  install(TARGETS ${APP} DESTINATION bin)
endmacro(marsyas_app)

## build apps
## in docs -gp
add_subdirectory(info)
add_subdirectory(mkcollection)
add_subdirectory(sfplay)
add_subdirectory(sfinfo)
add_subdirectory(audioCompare)
add_subdirectory(record)
add_subdirectory(orcarecord)
add_subdirectory(pitchextract)
add_subdirectory(bextract)
add_subdirectory(nextract)
add_subdirectory(phasevocoder)
add_subdirectory(kea)
add_subdirectory(peakSynth)
add_subdirectory(peakClustering)
add_subdirectory(peakClustering2)
add_subdirectory(WHaSp)
add_subdirectory(sfplugin)
add_subdirectory(mudbox)
add_subdirectory(rhythmMap)
add_subdirectory(sound2png)
add_subdirectory(sound2sound)
add_subdirectory(ibt)
add_subdirectory(pitchdtw)
add_subdirectory(speakerSeg)
add_subdirectory(wreckBeach)
add_subdirectory(openmir)

if(MARSYAS_OPENGL AND GLUT_FOUND)
  add_subdirectory(helloglut)
  add_subdirectory(carfac)
endif()

if(WITH_CPP11)
  add_subdirectory(debugger)
endif()

if(MARSYAS_REALTIME)
  add_subdirectory(runner)
  add_subdirectory(latency)
endif()

if(MARSYAS_SCRIPT)
  add_subdirectory(script_tools)
endif()

#add_subdirectory(msl) # NOT MULTIPLARTFORM (only UNIX)

## EVALUATION PROJECTS
add_subdirectory(mirex2008)
add_subdirectory(mirex2010)
add_subdirectory(peakClusteringEval)
# Disabled due to use of deprecated functionality of Delta MarSystem:
#add_subdirectory(mirex2009_tsunoo)
add_subdirectory(aim)

## not in docs; must edit tools.texi   -gp
add_subdirectory(tempo) 
add_subdirectory(virtualsensor)
add_subdirectory(onsets)
add_subdirectory(helloWorld)

=== src/marsyas/CMakeLists.txt ===
set( Marsyas_SOURCES
  system/MarControl.cpp
  system/MarControlManager.cpp
  system/MarControlValue.cpp
  system/MarSystem.cpp
  system/MarSystemManager.cpp

  sched/TmTimerManager.cpp
  sched/TmRealTime.cpp
  sched/TmParam.cpp
  sched/TmControlValue.cpp
  sched/TmSampleCount.cpp
  sched/EvGetUpd.cpp
  sched/TmTime.cpp
  sched/TmVirtualTime.cpp
  sched/Repeat.cpp
  sched/TmTimer.cpp
  sched/EvExpr.cpp
  sched/EvValUpd.cpp
  sched/EvEvent.cpp
  sched/Scheduler.cpp

  expr/ExSymTbl.cpp
  expr/Expr.cpp
  expr/ExScanner.cpp
  expr/ExNode.cpp
  expr/ExCommon.cpp
  expr/ExVal.cpp
  expr/ExParser.cpp

  realvec.cpp
  basis.cpp
  Collection.cpp
  Color.cpp
  CommandLineOptions.cpp
  Communicator.cpp
  Conversions.cpp
  fft.cpp
  FileName.cpp
  lu.cpp
  marohtml.cpp
  marojson.cpp
  marostring.cpp
  marosvg.cpp
  maroxml.cpp
  MATLABengine.cpp
  MrsLog.cpp
  NumericLib.cpp
  peakView.cpp
  PeUtilities.cpp
  QGMMModel.cpp
  statistics.cpp
  Stk.cpp
  Thread.cpp
  TimeLine.cpp
  Transcriber.cpp
  TranscriberExtract.cpp
  vmblock.cpp
  WekaData.cpp
)

if(MARSYAS_REALTIME)
  set(MARSYAS_REALTIME_SOURCES
    realtime/runner.cpp
    realtime/osc_receiver.cpp
    realtime/osc_transmitter.cpp
    realtime/udp_receiver.cpp
    realtime/udp_transmitter.cpp
    realtime/controller.cpp
  )
endif()

if(MARSYAS_SCRIPT)
  if(MARSYAS_REGENERATE_SCRIPT_PARSER)
    add_custom_command(
      OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/script/lex.cc"
      COMMAND flexc++ ARGS scanner.l
      DEPENDS script/scanner.l
      WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/script"
      COMMENT "Generating Marsyas script lexer"
    )

    add_custom_command(
      OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/script/parse.cc"
      COMMAND bisonc++ ARGS parser.y
      DEPENDS script/parser.y
      WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/script"
      COMMENT "Generating Marsyas script parser"
    )
  endif()

  list(APPEND Marsyas_SOURCES
    script/lex.cc
    script/parse.cc
    script/script.cpp
    script/manager.cpp
    script/operation_processor.cpp
  )

  set(parser_headers
    ${CMAKE_CURRENT_SOURCE_DIR}/script/scanner_impl.h
    ${CMAKE_CURRENT_SOURCE_DIR}/script/scanner.h
    ${CMAKE_CURRENT_SOURCE_DIR}/script/scannerbase.h
    ${CMAKE_CURRENT_SOURCE_DIR}/script/parser.h
    ${CMAKE_CURRENT_SOURCE_DIR}/script/parser_impl.h
    ${CMAKE_CURRENT_SOURCE_DIR}/script/parserbase.h
  )

  set_source_files_properties(
    script/lex.cc
    script/parse.cc
    PROPERTIES OBJECT_DEPENDS "${parser_headers}"
  )

endif()

if(WITH_CPP11)
  set(MARSYAS_DEBUG_SOURCES
    debug/recorder.cpp
    debug/debugger.cpp
    debug/file_io.cpp
  )
endif()

file(STRINGS marsystems/CMake-compile-cpp.txt
  MARSYAS_MARSYSTEMS_SOURCES)

foreach (filename ${MARSYAS_MARSYSTEMS_SOURCES})
	list(APPEND Marsyas_SOURCES marsystems/${filename})
endforeach()

if(MARSYAS_AUDIOIO)
	list(APPEND Marsyas_SOURCES
		Talk.cpp
		marsystems/AudioSource.cpp
		marsystems/AudioSourceBlocking.cpp
		marsystems/AudioSink.cpp
		marsystems/AudioSinkBlocking.cpp
	)
endif()

## OTHERLIBS

set( EXTERNALS_DIR ${CMAKE_SOURCE_DIR}/src/otherlibs )

if(MARSYAS_JSON)
  include_directories( ${EXTERNALS_DIR}/json++ )
  list(APPEND Marsyas_SOURCES json_io.cpp)
endif()

list(APPEND Marsyas_SOURCES ${EXTERNALS_DIR}/libsvm/svm.cpp)
list(APPEND Marsyas_SOURCES ${EXTERNALS_DIR}/liblinear/linear.cpp)
list(APPEND Marsyas_SOURCES ${EXTERNALS_DIR}/liblinear/tron.cpp)

list(APPEND Marsyas_SOURCES ${EXTERNALS_DIR}/liblinear/blas/daxpy.c)
list(APPEND Marsyas_SOURCES ${EXTERNALS_DIR}/liblinear/blas/ddot.c)
list(APPEND Marsyas_SOURCES ${EXTERNALS_DIR}/liblinear/blas/dnrm2.c)
list(APPEND Marsyas_SOURCES ${EXTERNALS_DIR}/liblinear/blas/dscal.c)


if (MARSYAS_PNG)
	list(APPEND Marsyas_SOURCES ${EXTERNALS_DIR}/pngwriter/pngwriter.cc)
endif (MARSYAS_PNG)


if (MARSYAS_ANN)
    set( ANN_DIR ${EXTERNALS_DIR}/ANN )
    list(APPEND Marsyas_SOURCES ${ANN_DIR}/bd_fix_rad_search.cpp)
    list(APPEND Marsyas_SOURCES ${ANN_DIR}/bd_pr_search.cpp)
    list(APPEND Marsyas_SOURCES ${ANN_DIR}/bd_search.cpp)
    list(APPEND Marsyas_SOURCES ${ANN_DIR}/bd_tree.cpp)
    list(APPEND Marsyas_SOURCES ${ANN_DIR}/brute.cpp)
    list(APPEND Marsyas_SOURCES ${ANN_DIR}/kd_dump.cpp)
    list(APPEND Marsyas_SOURCES ${ANN_DIR}/kd_fix_rad_search.cpp)
    list(APPEND Marsyas_SOURCES ${ANN_DIR}/kd_pr_search.cpp)
    list(APPEND Marsyas_SOURCES ${ANN_DIR}/kd_search.cpp)
    list(APPEND Marsyas_SOURCES ${ANN_DIR}/kd_split.cpp)
    list(APPEND Marsyas_SOURCES ${ANN_DIR}/kd_tree.cpp)
    list(APPEND Marsyas_SOURCES ${ANN_DIR}/kd_util.cpp)
    list(APPEND Marsyas_SOURCES ${ANN_DIR}/perf.cpp)
    list(APPEND Marsyas_SOURCES ${ANN_DIR}/ANN.cpp)
endif (MARSYAS_ANN)

if (MARSYAS_MAD)
    list(APPEND Marsyas_SOURCES marsystems/MP3FileSource.cpp)
    include_directories(${mad_INCLUDE_DIR})
endif (MARSYAS_MAD)

if (MARSYAS_PNG) 
    include_directories(${FREETYPE_INCLUDE_DIR_freetype2})
	include_directories(${FREETYPE_INCLUDE_DIR_ft2build})

endif (MARSYAS_PNG)

if (MARSYAS_LAME)
  list(APPEND Marsyas_SOURCES marsystems/MP3FileSink.cpp)
	include_directories(${lame_INCLUDE_DIR})
endif (MARSYAS_LAME)

if (MARSYAS_VORBIS)
    list(APPEND Marsyas_SOURCES marsystems/OggFileSource.cpp)
	include_directories(${VORBIS_INCLUDE_DIR})
endif (MARSYAS_VORBIS)

if (MARSYAS_GSTREAMER)
	list(APPEND Marsyas_SOURCES marsystems/GStreamerSource.cpp)
	include_directories(${GSTREAMER_INCLUDE_DIRS})
endif (MARSYAS_GSTREAMER)

if (MARSYAS_MATLAB)
#	list(APPEND Marsyas_SOURCES MATLABengine.cpp)
	include_directories(${MATLAB_INCLUDE_DIR})
endif (MARSYAS_MATLAB)  

if (MARSYAS_AUDIOIO)
	list(APPEND Marsyas_SOURCES ${EXTERNALS_DIR}/RtAudio/RtAudio.cpp)
	list(APPEND Marsyas_SOURCES ${EXTERNALS_DIR}/RtAudio/RtAudio3.cpp)
endif (MARSYAS_AUDIOIO)

if (MARSYAS_MIDIIO)
	list(APPEND Marsyas_SOURCES ${EXTERNALS_DIR}/RtMidi/RtMidi.cpp)
endif (MARSYAS_MIDIIO)


## DEFINE TARGET

set(MARSYAS_ALL_SOURCES
    ${Marsyas_SOURCES}
    ${MARSYAS_REALTIME_SOURCES}
    ${MARSYAS_DEBUG_SOURCES}
)

if(MARSYAS_STATIC)
  add_library(marsyas STATIC ${MARSYAS_ALL_SOURCES})
  set_target_properties(marsyas PROPERTIES OUTPUT_NAME "marsyas")
  set_target_properties(marsyas PROPERTIES CLEAN_DIRECT_OUTPUT 1)
else()
  add_library(marsyas SHARED ${MARSYAS_ALL_SOURCES})
endif()


## LINK

target_link_libraries(marsyas ${OS_LIBS})

if(MARSYAS_JSON)
  target_link_libraries(marsyas json++)
endif()

if(MARSYAS_OSC)
  target_link_libraries(marsyas ${OSCPACK_LIBRARIES})
endif()

if(MARSYAS_MAD)
  target_link_libraries(marsyas ${mad_LIBRARY})
endif(MARSYAS_MAD)

if(MARSYAS_PNG)
  if(MARSYAS_STATIC)
    target_link_libraries(marsyas png12_static)
  else()
    target_link_libraries(marsyas png12 ${FREETYPE_LIBRARY})
  endif()
  target_link_libraries(marsyas zlib)
endif(MARSYAS_PNG)

if(MARSYAS_LAME)
  target_link_libraries(marsyas ${lame_LIBRARY})
endif(MARSYAS_LAME)

if(MARSYAS_VORBIS)
  target_link_libraries(marsyas ${OGGVORBIS_LIBRARIES})
endif(MARSYAS_VORBIS)

if(MARSYAS_MATLAB)
  target_link_libraries(marsyas ${MATLAB_LIBRARIES})
endif(MARSYAS_MATLAB)

if(MARSYAS_GSTREAMER)
  target_link_libraries(marsyas ${GStreamer_LIBRARY})
  target_link_libraries(marsyas ${GStreamer-App_LIBRARY})
  target_link_libraries(marsyas ${Glib_LIBRARY})
  target_link_libraries(marsyas ${_GObjectLibs})
endif(MARSYAS_GSTREAMER)


## INSTALL

install( FILES
  basis.h
  Collection.h
  Color.h
  CommandLineOptions.h
  common_header.h
  common_source.h
  Communicator.h
  Conversions.h
  export.h
  dsound.h
  ERBTools.h
  fft.h
  FileName.h
  Heap.h
  lu.h
  marohtml.h
  marojson.h
  marostring.h
  marosvg.h
  maroxml.h
  types.h
  MATLABengine.h
  mididevices.h
  MrsLog.h
  NumericLib.h
  peakView.h
  PeUtilities.h
  QGMMModel.h
  static_vq_codebook.h
  statistics.h
  Stk.h
  StrobeList.h
  Thread.h
  TimeLine.h
  TranscriberExtract.h
  Transcriber.h
  vmblock.h
  WekaData.h
  realvec.h

  DESTINATION include/marsyas
)

if(MARSYAS_JSON)
  install( FILES json_io.h DESTINATION include/marsyas )
endif()

install( FILES
  system/MarControlAccessor.h
  system/MarControl.h
  system/MarControlManager.h
  system/MarControlValue.h
  system/MarSystem.h
  system/MarSystemManager.h

  DESTINATION include/marsyas/system
)

install( FILES
  sched/EvEvent.h
  sched/EvExpr.h
  sched/EvGetUpd.h
  sched/EvValUpd.h
  sched/Repeat.h
  sched/Scheduler.h
  sched/TmControlValue.h
  sched/TmParam.h
  sched/TmRealTime.h
  sched/TmSampleCount.h
  sched/TmTime.h
  sched/TmTimer.h
  sched/TmTimerManager.h
  sched/TmVirtualTime.h

  DESTINATION include/marsyas/sched
)

install( FILES
  expr/ExCommon.h
  expr/ExNode.h
  expr/ExParser.h
  expr/Expr.h
  expr/ExScanner.h
  expr/ExSymTbl.h
  expr/ExVal.h

  DESTINATION include/marsyas/expr
)

install( FILES
  realtime/any.h
  realtime/stage.h
  realtime/queue.h
  realtime/packet_queue.h
  realtime/realvec_queue.h
  realtime/atomic_control.h
  realtime/controller.h
  realtime/osc_receiver.h
  realtime/osc_transmitter.h
  realtime/udp_receiver.h
  realtime/udp_transmitter.h
  realtime/runner.h

  DESTINATION include/marsyas/realtime
)

install( FILES
  debug/debugger.h
  debug/record.h
  debug/recorder.h
  debug/file_io.h

  DESTINATION include/marsyas/debug
)

install( FILES
  script/script.h
  script/manager.h

  DESTINATION include/marsyas/script
)

# FIXME: Install headers for MarSystem subclasses
# after they are cleaned-up and good for public.

if (MARSYAS_STATIC)
  install(TARGETS marsyas
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib
  )
else (MARSYAS_STATIC)
  install(TARGETS marsyas
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib
  )

  if(WIN32 OR APPLE AND DEFINED PYTHON_MODULES_DIR)
    install(TARGETS marsyas
      RUNTIME DESTINATION ${PYTHON_MODULES_DIR}
      LIBRARY DESTINATION ${PYTHON_MODULES_DIR}
    )
  endif()
endif (MARSYAS_STATIC)

=== src/marsyas_max-msp/CMakeLists.txt ===
#Can't define target with ~ in MacOSX -> Best alternative "ibt~ "#
set(ibt_ext "ibt_")

project(${ibt_ext})

if(MARSYAS_WIN32)
# On Windows we need to include module definition (.def) file as well
set (MarMax_SOURCES
	MarMax~.cpp
	IBT~.cpp
	ibt~.def 
)
elseif(MARSYAS_MACOSX)
set (MarMax_SOURCES
	MarMax~.cpp
	IBT~.cpp
)
endif(MARSYAS_WIN32)

set (MarMax_HEADERS
	MarMax~.h
	IBT~.h
)

# (for now) only works on the static version of Marsyas
# we need to link to that specific archive library. 
# Also linking some additional libs/frameworks
if (MARSYAS_STATIC)

	# TESTED ON MAC/OSX (10.5.8) -> FOR XCODE ONLY!!! (tested on Xcode3.0) -> FOR i386arch (32bits) ONLY (Max/MSP only runs at 32bits, despite the OS architecture)
	if(MARSYAS_MACOSX)

		add_executable(${ibt_ext} MACOSX_BUNDLE ${MarMax_SOURCES} ${MarMax_HEADERS})

		include_directories(${MAXSDK_MAX_INCLUDE_DIR})
		include_directories(${MAXSDK_MSP_INCLUDE_DIR})
		#include_directories(/Developer/Headers/FlatCarbon)

		#link static Marsyas lib
		TARGET_LINK_LIBRARIES(${ibt_ext} "${LIBRARY_OUTPUT_PATH}/${CMAKE_BUILD_TYPE}/libmarsyas.a")
		
		#link audio/midi and XCode carbon frameworks
		FIND_LIBRARY(CARBON_LIBRARY Carbon)
		FIND_LIBRARY(COREAUDIO_LIBRARY CoreAudio)
		FIND_LIBRARY(COREMIDI_LIBRARY CoreMidi)
		TARGET_LINK_LIBRARIES(${ibt_ext} ${CARBON_LIBRARY} ${COREAUDIO_LIBRARY} ${COREMIDI_LIBRARY})
		
		#Pre-processor defines
		ADD_DEFINITIONS(-DMAC_VERSION)

		## LINKING with MaxSDK libs
		TARGET_LINK_LIBRARIES(${ibt_ext} ${MAXSDK_API_LIBRARY} ${MAXSDK_AUDIO_LIBRARY})

		# Max/MSP External specifications for XCode ONLY
		# Define Mach-O Type to Bundle
		SET_TARGET_PROPERTIES(${ibt_ext} PROPERTIES XCODE_ATTRIBUTE_MACH_O_TYPE "mh_bundle")
		# Define external extension as .mxo
		SET_TARGET_PROPERTIES(${ibt_ext} PROPERTIES XCODE_ATTRIBUTE_WRAPPER_EXTENSION "mxo")
		SET_TARGET_PROPERTIES(${ibt_ext} PROPERTIES XCODE_ATTRIBUTE_GCC_PREFIX_HEADER "${MAXSDK_MAINPATH}/c74support/max-includes/macho-prefix.pch")
		SET_TARGET_PROPERTIES(${ibt_ext} PROPERTIES XCODE_ATTRIBUTE_INFOPLIST_FILE "${MAXSDK_MAINPATH}/examples/Info.plist")
		SET_TARGET_PROPERTIES(${ibt_ext} PROPERTIES XCODE_ATTRIBUTE_WARNING_CFLAGS "-Wmost -Wno-four-char-constants -Wno-unknown-pragmas")
		SET_TARGET_PROPERTIES(${ibt_ext} PROPERTIES XCODE_ATTRIBUTE_DEPLOYMENT_LOCATION "YES")
		SET_TARGET_PROPERTIES(${ibt_ext} PROPERTIES XCODE_ATTRIBUTE_GENERATE_PKGINFO_FILE "YES")
		SET_TARGET_PROPERTIES(${ibt_ext} PROPERTIES XCODE_ATTRIBUTE_DSTROOT "${EXECUTABLE_OUTPUT_PATH}")
		SET_TARGET_PROPERTIES(${ibt_ext} PROPERTIES XCODE_ATTRIBUTE_INSTALL_PATH "/${CMAKE_BUILD_TYPE}")
		SET_TARGET_PROPERTIES(${ibt_ext} PROPERTIES XCODE_ATTRIBUTE_GCC_DYNAMIC_NO_PIC "NO")

	# TESTED ON WINDOWS (Windows7_64bits) -> FOR i386arch (32bits) ONLY (Max/MSP only runs at 32bits, despite the OS architecture)
	elseif(MARSYAS_WIN32)
	
		add_library(${ibt_ext} SHARED ${MarMax_SOURCES} ${MarMax_HEADERS})

		include_directories(${MAXSDK_MAX_INCLUDE_DIR})
		include_directories(${MAXSDK_MSP_INCLUDE_DIR})

		TARGET_LINK_LIBRARIES(${ibt_ext} marsyas)
		#Pre-processor defines
		ADD_DEFINITIONS(-DWIN_VERSION -DEXT_WIN_VERSION)
		# Define external extension as .mxe
		SET_TARGET_PROPERTIES(${ibt_ext} PROPERTIES SUFFIX ".mxe")

		## LINKING with MaxSDK libs
		TARGET_LINK_LIBRARIES(${ibt_ext} ${MAXSDK_API_LIBRARY} ${MAXSDK_CRT_LIBRARY} ${MAXSDK_AUDIO_LIBRARY})

	endif(MARSYAS_MACOSX)

#display warning if Marsyas not in STATIC mode (only works if statically linked to Marsyas lib)
else (MARSYAS_STATIC)
	 
	 message(SEND_ERROR "Only working linked statically to Marsyas lib - Please activate MARSYAS/MARSYAS_STATIC option")

endif (MARSYAS_STATIC)


if (MARSYAS_MAD)
	TARGET_LINK_LIBRARIES(${ibt_ext} ${mad_LIBRARY})
endif (MARSYAS_MAD)

if (MARSYAS_VORBIS)
	TARGET_LINK_LIBRARIES(${ibt_ext} ${OGGVORBIS_LIBRARIES})
endif (MARSYAS_VORBIS)

if (MARSYAS_MATLAB) 
	TARGET_LINK_LIBRARIES(${ibt_ext} ${MATLAB_LIBRARIES})
endif (MARSYAS_MATLAB)

if (GSTREAMER_FOUND)
	TARGET_LINK_LIBRARIES(${ibt_ext} ${GSTREAMER_LIBRARIES})
endif (GSTREAMER_FOUND)

=== src/marsyas_pd/CMakeLists.txt ===
set (ibtpd_SOURCES
	ibt_pd.cpp
	IBT.cpp
)

add_library(ibt_pd SHARED ${ibtpd_SOURCES})

#include for all platforms
include_directories(${PD_INCLUDE_DIR})

# In case we build the static version of Marsyas, we need to link
# to that specific archive library. Also linking some additional libs/frameworks
if (MARSYAS_STATIC)

	if(MARSYAS_MACOSX)
		set(MARSYAS_LIBRARY ${LIBRARY_OUTPUT_PATH}/libmarsyas.a)
		find_library(COREAUDIO CoreAudio "/System/Library/Frameworks")
		find_library(CARBON Carbon "/System/Library/Frameworks")
		TARGET_LINK_LIBRARIES(ibt_pd ${COREAUDIO} ${CARBON})
	elseif(MARSYAS_LINUX)
		set(MARSYAS_LIBRARY ${LIBRARY_OUTPUT_PATH}/libmarsyas.a)
	elseif(MARSYAS_WIN32)
		set(MARSYAS_LIBRARY marsyas)
	endif(MARSYAS_MACOSX)
	
else (MARSYAS_STATIC)
	# Cmake knows the location of the libraries it builds
	# the search path to the dynamic lib will automatically be added
	# maryas will result in  a "-lmarsyas" linker option.
	set(MARSYAS_LIBRARY marsyas)
endif (MARSYAS_STATIC)

## LINKING AND DEFINITIONS
if(MARSYAS_MACOSX)
	#define -undefined dynamic_lookup
	TARGET_LINK_LIBRARIES(ibt_pd ${MARSYAS_LIBRARY} "-undefined dynamic_lookup")
	#define dylib extension as .pd_darwin in MacOSX 
	SET_TARGET_PROPERTIES(ibt_pd PROPERTIES SUFFIX ".pd_darwin")
elseif(MARSYAS_LINUX)
	#define --export-dynamic -shared
	TARGET_LINK_LIBRARIES(ibt_pd ${MARSYAS_LIBRARY} "--export-dynamic -shared")
	#define so extension as .pd_linux in Linux 
	SET_TARGET_PROPERTIES(ibt_pd PROPERTIES SUFFIX ".pd_linux")
elseif(MARSYAS_WIN32)	
	#also link pd.lib
	TARGET_LINK_LIBRARIES(ibt_pd ${MARSYAS_LIBRARY} ${PD_LIB})
	#active Debug info in Release mode - for some reason when compiling with MSVC this is needed
	set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /debug")
	#add /export:ibt_pd_setup to export setup function from the dll
	set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /export:ibt_pd_setup")
	#Add MSW preprocessor definition
	add_definitions(-DMSW)
endif(MARSYAS_MACOSX)

#no lib prefix
SET_TARGET_PROPERTIES(ibt_pd PROPERTIES PREFIX "")

if (MARSYAS_MAD)
	TARGET_LINK_LIBRARIES(ibt_pd ${mad_LIBRARY})
endif (MARSYAS_MAD)

if (MARSYAS_VORBIS)
	TARGET_LINK_LIBRARIES(ibt_pd ${OGGVORBIS_LIBRARIES})
endif (MARSYAS_VORBIS)

if (MARSYAS_MATLAB) 
	TARGET_LINK_LIBRARIES(ibt_pd ${MATLAB_LIBRARIES})
endif (MARSYAS_MATLAB)

if (GSTREAMER_FOUND)
	TARGET_LINK_LIBRARIES(ibt_pd ${GSTREAMER_LIBRARIES})
endif (GSTREAMER_FOUND)

=== src/mvamp/CMakeLists.txt ===
set (MVamp_SOURCES
	ZeroCrossing.cpp
	MarsyasBExtractZeroCrossings.cpp
	MarsyasBExtractCentroid.cpp
	MarsyasBExtractLPCC.cpp
	MarsyasBExtractLSP.cpp
	MarsyasBExtractMFCC.cpp
	MarsyasBExtractRolloff.cpp
	MarsyasBExtractSCF.cpp
	MarsyasBExtractSFM.cpp
	MarsyasIBT.cpp
	plugins.cpp
)

add_library(mvamp SHARED ${MVamp_SOURCES})

include_directories(${VAMP_INCLUDE_DIR})

# In case we build the static version of Marsyas, we need to link
# to that specific archive library. Also linking some additional libs/frameworks
if (MARSYAS_STATIC)

	if(MARSYAS_MACOSX)
		set(MARSYAS_LIBRARY ${LIBRARY_OUTPUT_PATH}/libmarsyas.a)
		find_library(COREAUDIO CoreAudio "/System/Library/Frameworks")
		find_library(CARBON Carbon "/System/Library/Frameworks")
		TARGET_LINK_LIBRARIES(mvamp ${COREAUDIO} ${CARBON})
	elseif(MARSYAS_LINUX)
		set(MARSYAS_LIBRARY ${LIBRARY_OUTPUT_PATH}/libmarsyas.a)
	elseif(MARSYAS_WIN32)
		set(MARSYAS_LIBRARY marsyas)
	endif(MARSYAS_MACOSX)
	
else (MARSYAS_STATIC)
	# Cmake knows the location of the libraries it builds
	# the search path to the dynamic lib will automatically be added
	# maryas will result in  a "-lmarsyas" linker option.
	set(MARSYAS_LIBRARY marsyas)
endif (MARSYAS_STATIC)

## LINKING
TARGET_LINK_LIBRARIES(mvamp ${MARSYAS_LIBRARY} ${VAMP_LIBRARY})

# take lib prefix out
set_target_properties(mvamp PROPERTIES PREFIX "")
if(MARSYAS_WIN32)
	#add/EXPORT:vampGetPluginDescriptor to Visual Studio project (as referred in http://vamp-plugins.org/wiki/mtp2)
	set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /EXPORT:vampGetPluginDescriptor")
endif(MARSYAS_WIN32)

if (MARSYAS_MAD)
	TARGET_LINK_LIBRARIES(mvamp ${mad_LIBRARY})
endif (MARSYAS_MAD)

if (MARSYAS_VORBIS)
	TARGET_LINK_LIBRARIES(mvamp ${OGGVORBIS_LIBRARIES})
endif (MARSYAS_VORBIS)

if (MARSYAS_MATLAB) 
	TARGET_LINK_LIBRARIES(mvamp ${MATLAB_LIBRARIES})
endif (MARSYAS_MATLAB)

if (GSTREAMER_FOUND)
	TARGET_LINK_LIBRARIES(mvamp ${GSTREAMER_LIBRARIES})
endif (GSTREAMER_FOUND)

=== src/otherlibs/CMakeLists.txt ===
if(MARSYAS_JSON)
  add_subdirectory(json++)
endif()

# if(MARSYAS_AUDIOIO)
#        add_subdirectory(RtAudio)
# endif(MARSYAS_AUDIOIO)

# if(MARSYAS_MIDIIO)
#        add_subdirectory(RtMidi)
# endif(MARSYAS_MIDIIO)

if(MARSYAS_OSC)
  add_subdirectory(oscpack)
endif()

if(MARSYAS_PNG) 
  add_subdirectory(zlib-1.2.3)
  add_subdirectory(libpng-1.2.35)
endif(MARSYAS_PNG)

if(WITH_QT)
  add_subdirectory(qwt)
endif()

=== src/qt5apps/CMakeLists.txt ===
find_package(Qt5Quick 5.1 REQUIRED)
find_package(Qt5Widgets 5.1 REQUIRED)
if(MARSYAS_OPENGL)
  find_package(Qt5OpenGL 5.1 REQUIRED)
endif()

get_target_property(qt5_core_filename Qt5::Core LOCATION)
get_filename_component(qt5_core_dir ${qt5_core_filename} PATH)
if(APPLE)
  get_filename_component(qt5_dir ${qt5_core_dir}/../.. ABSOLUTE)
else()
  get_filename_component(qt5_dir ${qt5_core_dir}/.. ABSOLUTE)
endif()

add_subdirectory(common)

macro(marsyas_qt5_app APP)
  if(WIN32 AND NOT MSVC)
    add_executable(${APP} WIN32 ${ARGN})
  else()
    add_executable(${APP} ${ARGN})
  endif()

  target_link_libraries(${APP} marsyas marsyas-qt5)

  if(MSVC)
    set_property( TARGET ${APP} APPEND PROPERTY LINK_FLAGS_RELEASE "/SUBSYSTEM:windows /ENTRY:mainCRTStartup" )
  endif()

  # Do not install on Mac OS because of absolute paths to Qt dependencies
  if(NOT APPLE)
     install(TARGETS ${APP} DESTINATION bin)
  endif()
endmacro()

if(WITH_CPP11)
  add_subdirectory(inspector)
endif()

if(MARSYAS_AUDIOIO AND MARSYAS_REALTIME)
  add_subdirectory(MarPlayer)
  if(MARSYAS_MIDIIO)
    add_subdirectory(MarGrid2)
  endif()
  add_subdirectory(MarPhasevocoder)
  add_subdirectory(MarLpc)
  if(MARSYAS_OPENGL)
    add_subdirectory(MarPanning)
    add_subdirectory(MarSndPeek)
    add_subdirectory(MarCorrelogram)
  endif()
endif()

if(WIN32)
  install(FILES ${qt5_dir}/plugins/platforms/qwindows.dll DESTINATION bin/platforms)
  install(DIRECTORY ${qt5_dir}/qml/QtQuick.2 DESTINATION bin)
  install(DIRECTORY ${qt5_dir}/qml/QtQuick/Layouts DESTINATION bin/QtQuick)
endif()

=== src/swig/CMakeLists.txt ===
# setup OS_LIBS
include (marsyas-oslibs)

# global swig stuff
#find_package(SWIG REQUIRED)
include(${SWIG_USE_FILE})


## build apps
if (WITH_SWIG_PYTHON)
	add_subdirectory(python)
endif (WITH_SWIG_PYTHON)
if (WITH_SWIG_JAVA)
	add_subdirectory(ruby)
endif (WITH_SWIG_JAVA)
if (WITH_SWIG_LUA)
	add_subdirectory(lua)
endif (WITH_SWIG_LUA)
if (WITH_SWIG_RUBY)
	add_subdirectory(ruby)
endif (WITH_SWIG_RUBY)

=== PKGBUILD ===
# Maintainer: David Runge <dvzrv@archlinux.org>
# Contributor: Felix Yan <felixonmars@archlinux.org>
# Contributor: MeMi69 <MetalMilitia@gmx.net>

pkgname=marsyas
pkgver=0.5.0
pkgrel=8
pkgdesc="Music Analysis, Retrieval and Synthesis for Audio Signals"
arch=('x86_64')
url="http://marsyas.info"
license=('GPL2')
groups=('pd-externals' 'pro-audio' 'vamp-plugins')
depends=('gcc-libs' 'glibc' 'lame' 'libmad')
makedepends=('alsa-lib' 'cmake' 'doxygen' 'extra-cmake-modules' 'jack'
'libvorbis' 'pd' 'qt5-base' 'qt5-declarative' 'vamp-plugin-sdk')
optdepends=('pd: for ibt_pd external'
            'qt5-base: for MarGrid2, MarLpc, MarPhasevocoder, MarPlayer and marsyas-inspector'
            'qt5-declarative: for marsyas-inspector'
            'vamp-plugin-sdk: for vamp plugin')
provides=('libmarsyas.so')
source=(
  "$pkgname-$pkgver.tar.gz::https://github.com/${pkgname}/${pkgname}/archive/version-$pkgver.tar.gz"
  "${pkgname}-0.5.0-qpainterpath.patch"
  "${pkgname}-0.5.0-vamp_include_dirs.patch"
  "${pkgname}-0.5.0-pd_extension.patch"
)
sha512sums=('0ff8943028753c70d409e78a8c5487da2006b7599c8909c0e0050433a6e7051f32b3c5f31fe833085a479d0486e4c96c5f4a4bd63ac00ee68b89dee941aebc9a'
            'a1a61964f3588b58ee95c16b70a1641b13032c07ec1fba030a9f5fa62c9f355f0c67a147dcdd04d70b0ef5d3a513fbe07341e73abeab3cce82cdfa65385fe22e'
            '29d6a67195241d67b16da9afe522741cbdbfda84183f40f205d50d133bb8ebbcfebff01f011351851660bd59c6bb8cf629316de6345801caf6e0a41c7eeb354c'
            '028329689ba460266b673a88d4ac316dd1077f93c6f2a5b3283961a457bf34fca64222b62f24d5478436c53a4868bd2a7337ffc1802089a2d829b3707ea48c6d')

prepare() {
  mv -v "${pkgname}-version-${pkgver}" "${pkgname}-${pkgver}"
  cd "${pkgname}-${pkgver}"
  # add missing include for QPainterPath (offered upstream):
  # https://github.com/marsyas/marsyas/issues/77
  patch -Np1 -i ../"${pkgname}-0.5.0-qpainterpath.patch"
  # fix include dirs for vamp plugins (offered upstream):
  # https://github.com/marsyas/marsyas/issues/79
  patch -Np1 -i ../"${pkgname}-0.5.0-vamp_include_dirs.patch"

  # fixing build of pd external (offered upstream):
  # https://github.com/marsyas/marsyas/issues/81
  patch -Np1 -i ../"${pkgname}-0.5.0-pd_extension.patch"
}

build() {
  cd "${pkgname}-${pkgver}"
  # disable build of python module, as it is python2 only:
  # https://github.com/marsyas/marsyas/issues/71
  cmake -DCMAKE_INSTALL_PREFIX=/usr \
        -DCMAKE_SKIP_RPATH=ON \
        -DWITH_MAD=ON \
        -DWITH_LAME=ON \
        -DWITH_PD=ON \
        -DWITH_SWIG=OFF \
        -DWITH_VAMP=ON \
        -DWITH_VORBIS=ON \
        -B build \
        -S .
  make VERBOSE=1 -C build
}

package() {
  depends+=('libasound.so' 'libjack.so' 'libvorbisfile.so')
  cd "${pkgname}-${pkgver}"
  make DESTDIR="$pkgdir" install -C build
  # pd external
  install -vDm 755 build/lib/ibt_pd.pd_linux \
    -vDm 644 src/${pkgname}_pd/ibt_pd-help.pd \
    -t "${pkgdir}/usr/lib/pd/extra/"
  # vamp plugin
  install -vDm 755 build/lib/mvamp.so -t "${pkgdir}/usr/lib/vamp"
  # docs
  install -vDm 644 {AUTHORS,README,TODO} \
    -t "${pkgdir}/usr/share/doc/${pkgname}"
  # rename sfinfo https://bugs.archlinux.org/task/60787
  mv -v "${pkgdir}/usr/bin/sfinfo" "${pkgdir}/usr/bin/${pkgname}-sfinfo"
  # rename record: https://bugs.archlinux.org/task/69837
  mv -v "${pkgdir}/usr/bin/record" "${pkgdir}/usr/bin/${pkgname}-record"
}
